local DEBUG = 0
local OnEvent = {}
local UpdateInterval = 1
local TimeSinceLastUpdate = 0
local UpdateEventNext = 0
local frame = CreateFrame("Frame")

local function ComputeDistance(unit1, unit2)
   local y1, x1, _, instance1 = UnitPosition(unit1)
   local y2, x2, _, instance2 = UnitPosition(unit2)
   return instance1 == instance2 and ((x2 - x1) ^ 2 + (y2 - y1) ^ 2) ^ 0.5
end


function OnEvent.INSTANCE_ENCOUNTER_ENGAGE_UNIT(...)
   SetMapToCurrentZone()
   if (DEBUG == 1) then
      print("SetMapToCurrentZone")
   end
end

function OnEvent.COMBAT_LOG_EVENT_UNFILTERED(...)
   local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = select(1, ...)
   if (type == "SPELL_CAST_START") then
      local spellId, spellName, spellSchool = select(12, ...)
      if(spellId == 180300) then
         TimeSinceLastUpdate = 0
         UpdateInterval = 2
         UpdateEventNext = 6
      end
   end

   if (type == "SPELL_DAMAGE") then
      local spellId, spellName, spellSchool = select(12, ...)
      if(spellId == 180260 or spellId == 180252) then
         if (DEBUG == 1) then
            print(destName .. " got hit by " .. spellName)
         end
         local playerName = UnitName("player")
         if (destName == playerName) then
            SendChatMessage("fire under me","yell")
         end
         local dest = ComputeDistance("player", destName)
         if (dest ~= false and dest <= 3.5) then
            PlaySoundFile("Interface\\AddOns\\VelhariHelper\\alert.mp3", "Master")
         end
         if ( DEBUG == 1 and dest == false ) then
            print("dest is false")
         end
      end
   end
   
end
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
frame:RegisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")
frame:SetScript("OnEvent",function(_, e, ...)OnEvent[e](...)end)



frame:SetScript("OnUpdate", function(self, elapsed)
      TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed; 
      while (TimeSinceLastUpdate > UpdateInterval) do
         
         TimeSinceLastUpdate = TimeSinceLastUpdate - UpdateInterval;
         if(UpdateEventNext == 6 or UpdateEventNext == 3)then
            UpdateInterval = 1
            PlaySoundFile("Interface\\AddOns\\VelhariHelper\\beep_long_a.mp3", "Master")
         elseif (UpdateEventNext == 5 or UpdateEventNext == 2) then
            PlaySoundFile("Interface\\AddOns\\VelhariHelper\\beep_long_a.mp3", "Master")
         elseif (UpdateEventNext == 4 or UpdateEventNext == 1) then
            PlaySoundFile("Interface\\AddOns\\VelhariHelper\\beep_long_b.mp3", "Master")
         end
         UpdateEventNext = UpdateEventNext - 1
         
      end
end)


